-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- edit_stages.lua

edit_stages = { ID = 0 }

-- print "[edit_stages]"

-- creation
function edit_stages:new (o)
	-- print "[edit_stages] new edit_stages"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	btn_w = 60
	btn_h = 30
	--
	-- list window
	--
	x = 10
	y = 60
	window_edit_stages_list = sim:addWindow( 1000, xcore.x2drect(x, y, x+128, y+256+60), "Stage List")
	window_edit_stages_list:setTitleBarVisible( false )		
	image_background_edit_list = sim:addImage( 0, texture_background_128x256, xcore.x2dpoint(0, 0),
		xcore.x2drect(0,0,64,64), xcore.xcolour(255,255,255,255) )
	image_background_edit_list:setParent( window_edit_stages_list )
	
	-- list
	width = 118	
	x = 5
	y = 10
	height = 236
	listbox_edit_stages = sim:addListbox( 1010, true, xcore.x2drect( x,y,x+width,y+height ) )
	listbox_edit_stages:setParent( window_edit_stages_list )
	listbox_edit_stages:addItem("test")
	x = 0
	y = 256

	button_edit_stages_edit = sim:addButton( 2202, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Edit" )
	button_edit_stages_edit:setParent( window_edit_stages_list )		
	button_edit_stages_edit:setImage( button_small_texture )
	button_edit_stages_edit:setPressedImage( button_small_pressed_texture )	

	x = x+ btn_w + 6
	button_edit_stages_delete = sim:addButton( 2203, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Delete" )
	button_edit_stages_delete:setParent( window_edit_stages_list )		
	button_edit_stages_delete:setImage( button_small_texture )
	button_edit_stages_delete:setPressedImage( button_small_pressed_texture )	

	x = 0
	y = y + 30
	btn_w = 128
	-- add some buttons
	button_edit_stages_add = sim:addButton( 2201, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Add" )
	button_edit_stages_add:setParent( window_edit_stages_list )	
	button_edit_stages_add:setImage( button_texture )
	button_edit_stages_add:setPressedImage( button_pressed_texture )	
	
	sim:bindGUI ( "button_edit_stages_add_pressed", 2201, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_stages_edit_pressed", 2202, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_edit_stages_delete_pressed", 2203, xcore.XGUI_BUTTON_CLICKED )

	--
	-- data window
	--
	x = 260
	y = 60
	window_edit_stages_data = sim:addWindow( 1000, xcore.x2drect(x, y, x+380, y+400), "Stage Data")	
	
	y = 30
	x = 20
	-- add input for name
	label_edit_stages_name = sim:addText( 0, "Name", x, y, x+100, y+20 )
	label_edit_stages_name:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_name = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_name:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add input for name
	label_edit_stages_seq = sim:addText( 0, "Stage No.", x, y, x+100, y+20 )
	label_edit_stages_seq:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_seq = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_seq:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add inputs for tile type
	label_edit_stages_type = sim:addText( 0, "Type", x, y, x+100, y+20 )
	label_edit_stages_type:setParent( window_edit_stages_data )
	x = x+110
	combobox_edit_stages_type = sim:addCombobox( 100, xcore.x2drect(x, y, x+150, y+20 ) )
	combobox_edit_stages_type:setParent( window_edit_stages_data )
	combobox_edit_stages_type:addItem("TILESET_DUNGEON")
	combobox_edit_stages_type:addItem("TILESET_FOREST")
	combobox_edit_stages_type:addItem("TILESET_CAVE")
	combobox_edit_stages_type:addItem("TILESET_MAZE")
	combobox_edit_stages_type:addItem("TILESET_CASTLE")
	
	y = y + 30
	x = 20		
	label_edit_stages_desc = sim:addText( 0, "Desc", x, y, x+100, y+20 )
	label_edit_stages_desc:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_desc = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_desc:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add inputs for depth
	label_edit_stages_depth = sim:addText( 0, "Depth", x, y, x+100, y+20 )
	label_edit_stages_depth:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_depth = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_depth:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add inputs for size
	label_edit_stages_size = sim:addText( 0, "Size", x, y, x+100, y+20 )
	label_edit_stages_size:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_size = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_size:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add inputs for min
	label_edit_stages_level_min = sim:addText( 0, "Ch.Lv.Min", x, y, x+100, y+20 )
	label_edit_stages_level_min:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_level_min = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_level_min:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add inputs for max
	label_edit_stages_level_max = sim:addText( 0, "Ch.Lv.Max", x, y, x+100, y+20 )
	label_edit_stages_level_max:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_level_max = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_level_max:setParent( window_edit_stages_data )	

	y = y + 30
	x = 20		
	-- add inputs for max
	label_edit_stages_reward = sim:addText( 0, "Reward", x, y, x+100, y+20 )
	label_edit_stages_reward:setParent( window_edit_stages_data )
	x = x+110
	textfield_edit_stages_reward = sim:addEditbox( 20,  xcore.x2drect( x,y,x+200,y+20 ) )
	textfield_edit_stages_reward:setParent( window_edit_stages_data )	

	y = y + 50
	btn_w = 160
	x = 120
	button_edit_stages_save = sim:addButton( 2211, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Save" )
	button_edit_stages_save:setParent( window_edit_stages_data )		
	button_edit_stages_save:setImage( button_texture )
	button_edit_stages_save:setPressedImage( button_pressed_texture )
	
	sim:bindGUI ( "button_edit_stages_save_pressed", 2211, xcore.XGUI_BUTTON_CLICKED )

	stat_id = -1
	self.mode = 1
	self.current_tile_id = -1

	self:hide()
	return o
end

function edit_stages:hide()
	-- print "[edit_stages] hide"
	window_edit_stages_list:setVisible( false )
	window_edit_stages_data:setVisible( false )
end


function edit_stages:show()
	-- print "[edit_stages] show"
	self:updateList()

	window_edit_stages_list:setVisible( true )
	-- print "[edit_stages] /show"
end

function edit_stages:destroy()
	-- print "[edit_stages] destroy"
	window_edit_stages_list:destroy()
end

function edit_stages:input()
	if sim:isGUI( "button_edit_stages_add_pressed" ) then
		window_edit_stages_data:setVisible( true )
		self:showAdd()
	end
	if sim:isGUI( "button_edit_stages_edit_pressed" ) then
		window_edit_stages_data:setVisible( true )
		self:showEdit()
	end
	if sim:isGUI( "button_edit_stages_delete_pressed" ) then
		self:delete()
	end	
	if sim:isGUI( "button_edit_stages_save_pressed" ) then
		self:save()
	end	
end

function edit_stages:save()
	-- print("[edit_stages] save")
	if self.mode == 1 then
		query = " INSERT INTO table_stages "
		query = query .. " ( stage_name, stage_type, stage_desc, stage_depth, stage_size, stage_level_min, stage_level_max, stage_sequence, stage_reward )"
		query = query .. "VALUES ( "
		query = query .. "'".. textfield_edit_stages_name:getText() .. "', "
		query = query .. "'".. combobox_edit_stages_type:getSelected() .. "', "
		query = query .. "'".. textfield_edit_stages_desc:getText() .. "', "
		query = query .. "'".. textfield_edit_stages_depth:getText() .. "', "
		query = query .. "'".. textfield_edit_stages_size:getText() .. "', "
		query = query .. "'".. textfield_edit_stages_level_min:getText() .. "', "
		query = query .. "'".. textfield_edit_stages_level_max:getText() .. "',"
		query = query .. " ".. textfield_edit_stages_seq:getText() .. ", "
		query = query .. " ".. textfield_edit_stages_reward:getText() .. " "
		query = query .. " )"
		-- print( query )
		sql:exe( query )
	else
		query = "UPDATE table_stages SET "
		query = query .. " stage_name = '" .. textfield_edit_stages_name:getText() .. "', "
		query = query .. " stage_type = '" .. combobox_edit_stages_type:getSelected() .. "', "
		query = query .. " stage_desc = '" .. textfield_edit_stages_desc:getText() .. "', "
		query = query .. " stage_depth = '" .. textfield_edit_stages_depth:getText() .. "', "
		query = query .. " stage_size = '" .. textfield_edit_stages_size:getText() .. "', "
		query = query .. " stage_level_min = '" .. textfield_edit_stages_level_min:getText() .. "', "
		query = query .. " stage_level_max = '" .. textfield_edit_stages_level_max:getText() .. "', "
		query = query .. " stage_sequence = ".. textfield_edit_stages_seq:getText() .. ", "
		query = query .. " stage_reward = ".. textfield_edit_stages_reward:getText() .. " "
		query = query .. " WHERE stage_id = " .. self.current_stage_id
		-- print( query )
		sql:exe( query )
	end
	self:updateList()
end

function edit_stages:delete()
	if listbox_edit_stages:getSelected() == -1 then return nil end
	n = listbox_edit_stages:getItem( listbox_edit_stages:getSelected() )
	-- print("[edit_stages] delete tile : " .. n)
	
	query = "DELETE FROM table_stages WHERE stage_name = '" ..  n .. "'"
	local q = sql:exe( query )
	
	self:updateList()
end

function edit_stages:showAdd()
	self.mode = 1
	-- print "[edit_stages] showAdd"
	-- show confirmation
	textfield_edit_stages_name:setText("")
	combobox_edit_stages_type:setSelected( 0 )
	textfield_edit_stages_desc:setText("")
	textfield_edit_stages_depth:setText("")
	textfield_edit_stages_size:setText("")
	textfield_edit_stages_level_min:setText("")	
	textfield_edit_stages_level_max:setText("")

end

function edit_stages:showEdit()
	self.mode = 2
	-- print "[edit_stages] showEdit"

	-- show confirmation
	n = listbox_edit_stages:getItem( listbox_edit_stages:getSelected() )
	-- print("[edit_stages] edit item : " .. n)
	query = "SELECT stage_name, stage_type, stage_desc, stage_depth, stage_size, stage_level_min, stage_level_max, stage_id, stage_sequence, stage_reward FROM table_stages WHERE stage_name = '" ..  n .. "'"
	local q = sql:exe( query )
	if q ~= nil then
		if q:getData( 0 ) ~= nil then
			-- print ("[edit_stages] name : " .. q:getData( 0 ) )
			textfield_edit_stages_name:setText( q:getData( 0 ) )
		end
		if q:getData( 1 ) ~= nil then
			-- print ( q:getData( 1 ) )
			if tonumber( q:getData( 1 ) ) ~= nil then
				combobox_edit_stages_type:setSelected( tonumber( q:getData( 1 ) )  )
			else
				combobox_edit_stages_type:setSelected( 0 )
			end
		end
		if q:getData( 2 ) ~= nil then
			-- print ( q:getData( 2 ) )
			textfield_edit_stages_desc:setText( q:getData( 2 ) )	
		end
		if q:getData( 3 ) ~= nil then
			textfield_edit_stages_depth:setText( tonumber( q:getData( 3 ) ) )
		end
		if q:getData( 4 ) ~= nil then
			textfield_edit_stages_size:setText( q:getData( 4 ) )
		end		
		if q:getData( 5 ) ~= nil then
			textfield_edit_stages_level_min:setText( q:getData( 5 ) )
		end
		if q:getData( 6 ) ~= nil then
			textfield_edit_stages_level_max:setText( q:getData( 6 ) )
		end

		self.current_stage_id = tonumber( q:getData( 7 ) )
		
		if q:getData( 8 ) ~= nil then
			textfield_edit_stages_seq:setText( q:getData( 8 ) )
		end	
		if q:getData( 9 ) ~= nil then
			textfield_edit_stages_reward:setText( q:getData( 9 ) )
		end			
	end
end

function edit_stages:showDelete()
	-- print "[edit_stages] showDelete"
	-- show confirmation
end

function edit_stages:updateList()
	-- print "[edit_stages] updateList"
	listbox_edit_stages:clear()
	statement = "SELECT stage_name FROM table_stages WHERE 0 = 0 ORDER BY stage_sequence ASC "
	local q = sql:exe( statement )
	if q ~= nil then
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
				listbox_edit_stages:addItem( q:getData( i ) )
		end
	end
	sql:removeResult( q )
	window_edit_stages_data:setVisible( false )
end

-- end of file