-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- logistics.lua

logistics = { ID = 0 }

-- print "[logistics]"

-- creation
function logistics:new (o)
	-- print "[logistics] new logistics"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	-- what about gui text elements?

	width = 128
	height = 20
	x = screen_width - width - 40
	y = 100

	btn_w = 128
	btn_h = 30
	space = btn_w + 4

	-- listbox_abilities = sim:addListbox( 2203, true, xcore.x2drect(x+10, y, x+width-50, y+180 ) )
	logistics_window = sim:addWindow( 200, xcore.x2drect(x, y, x+width, y+180), "Logistics")
	logistics_window:setTitleBarVisible( false )

	x = 0
	y = 0
	button_logistics_selector = sim:addButton( 262, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Quests" )
	button_logistics_selector:setParent( logistics_window )
	button_logistics_selector:setImage( button_texture )
	button_logistics_selector:setPressedImage( button_pressed_texture )	

	y = y+btn_h
	button_logistics_creator = sim:addButton( 264, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Party" )
	button_logistics_creator:setParent( logistics_window )	
	button_logistics_creator:setImage( button_texture )
	button_logistics_creator:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_logistics_vendor = sim:addButton( 263, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Vendor" )
	button_logistics_vendor:setParent( logistics_window )	
	button_logistics_vendor:setImage( button_texture )
	button_logistics_vendor:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_logistics_medical = sim:addButton( 266, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Temple" )
	button_logistics_medical:setParent( logistics_window )	
	button_logistics_medical:setImage( button_texture )
	button_logistics_medical:setPressedImage( button_pressed_texture )

	--[[
	y = y+btn_h
	button_logistics_storage = sim:addButton( 265, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Warehouse" )
	button_logistics_storage:setParent( logistics_window )	
	button_logistics_storage:setImage( button_texture )
	button_logistics_storage:setPressedImage( button_pressed_texture )

	y = y+btn_h
	button_logistics_arena = sim:addButton( 265, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Arena" )
	button_logistics_arena:setParent( logistics_window )	
	button_logistics_arena:setImage( button_texture )
	button_logistics_arena:setPressedImage( button_pressed_texture )
	--]]
	
	y = y+btn_h
	button_logistics_exit = sim:addButton( 267, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Exit" )
	button_logistics_exit:setParent( logistics_window )	
	button_logistics_exit:setImage( button_texture )
	button_logistics_exit:setPressedImage( button_pressed_texture )

	sim:bindGUI ( "button_logistics_selector_pressed", 262, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_logistics_vendor_pressed", 263, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_logistics_creator_pressed", 264, xcore.XGUI_BUTTON_CLICKED )
	-- sim:bindGUI ( "button_logistics_storage_pressed", 265, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_logistics_medical_pressed", 266, xcore.XGUI_BUTTON_CLICKED )
	sim:bindGUI ( "button_logistics_exit_pressed", 267, xcore.XGUI_BUTTON_CLICKED )

	self:hide()
	-- print "[logistics] new logistics"
	return o
end

function logistics:hide()
	-- print "[logistics] hide"
	logistics_window:setVisible( false )
end

function logistics:show()
	-- print "[logistics] show"
	logistics_window:setVisible( true )
	-- print "[logistics] /show"
end

function logistics:destroy()
	-- print "[logistics] destroy"
	button_attack:destroy()
	button_move:destroy()
	-- etc
	
	logistics_window:destroy()
end

-- end of file