-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- state_about.lua

state_about = state:new()

-- creation
function state_about:new (o)
	-- print "[state_about] new state_about"
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	substate = 0

	width = 512
	height = 312
	x = (screen_width/2) - (width/2)	
	y = (screen_height/2) - (height/2)

	txt = [[
	Dungeon Tactics

	Copyright 2012 Lukas W. Irwin

	xhrit ( Lukas W. Irwin ) - Game Design, Programming
	wulax ( Johannes Sjolund ) - Character Art
	pennomi - User Interface Art
	laetissima - User Interface Art

	Art LPC CC BY-SA 3.0
	Code GPLv3

	Made with XENOS ENGINE 




	For more information visit
	www.dungeon-tactics.com









	]]
	about_text = sim:addText( 0, txt, x, y, x+width, y+height  )
	about_text:setAlignment( 2, 0)

	btn_w = 200
	btn_h = 30
	
	x = screen_width/2-(btn_w/2)
	y = screen_height-128
	button_about_exit = sim:addButton( 901, xcore.x2drect( x, y, x+btn_w, y+btn_h ), "Back" )
	button_about_exit:setVisible( false )
	button_about_exit:setImage( button_texture )
	button_about_exit:setPressedImage( button_pressed_texture )
	
	sim:bindGUI ( "button_about_exit_pressed", 901, xcore.XGUI_BUTTON_CLICKED )

	self:hide()
	return o
end

-- called on state_about enter
function state_about:enter ()
	-- print "[state_about] enter state_about"
	self:show()
	-- menu_text:setText("About")
	
	-- data_text:setText( txt )
	-- print "[state_about] /enter"
end

-- called on state_about exit
function state_about:exit ()
	-- print "[state_about] exit state_about"
	self:hide()

end

function state_about:show ()
	-- print "[state_about] show"
	about_text:setVisible( true )
	button_about_exit:setVisible( true )
	text_title:setVisible( true )
	text_title:setText( "About" )
	image_background_title:setVisible( true )	

end

function state_about:hide ()
	-- print "[state_about] hide"
	about_text:setVisible( false )
	button_about_exit:setVisible( false )
	text_title:setVisible( false )
	text_title:setText( "High Scores" )
	image_background_title:setVisible( false )	
end

-- called to advance state_about
function state_about:input ()
	-- print ( "[state_about] input")
	r = ENUM_ABOUT
	if sim:isKey( "key_pressed_exit_state" ) then r = ENUM_MENU end
	if sim:isGUI( "button_scores_exit_pressed" ) then return ENUM_MENU end

	sim:update()
	return r
end

-- called when changing state_about
function state_about:transition ( i ) -- transition to state_about v
	print "[state_about] transition"
end
