-- Dungeon Tactics
-- Copyright 2012 lukas w. irwin [ lukas.w.irwin@gmail.com ]
-- This program is free software under the terms of the GNU General Public License version 3 or later.
-- user.lua

user = { ID = 0 }

-- creation
function user:new (o)
	-- print "[user] new user"
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	self.ID       = 0
	self.name     = "default user"

	self.gold      = 0	
	self.score     = 0
	self.kills     = 0
	self.deaths    = 0
	self.sequence  = 0

	o.inventory = {}

	return o
end

function user:destroy()
	-- TODO: remove inventory
	-- reset stats
end

function user:setID ( n ) self.ID = n end
function user:getID () return self.ID end

function user:setScore ( n ) self.score = n end
function user:getScore () return self.score end

function user:setKills ( n ) self.kills = n end
function user:getKills () return self.kills end

function user:load()
	-- print("[user] load")
	statement =             " SELECT user_id, user_name, user_gold, user_sequence "
	statement = statement .." FROM table_users "
	statement = statement .." WHERE user_id = 1 "
	-- print( statement )
	local q = sql:exe( statement )
	if q ~= nil then
		-- print ("returned " .. q:getRowCount() .. " rows ")		
		for i = 0, q:getRowCount()-1 do
			local n = i*q:getHeadCount()
			if q:getData( n+1 ) ~= nil then self.name = q:getData( n+1 ) else self.name = "default user" end	
			if q:getData( n+2 ) ~= nil then self.gold = tonumber(q:getData( n+2 ) ) else self.gold = 100 end
			if q:getData( n+3 ) ~= nil then self.sequence = tonumber(q:getData( n+3 ) ) else self.sequence = 0 end
		end
	end
end

function user:save()
	-- print("[user] save")
	statement = "UPDATE table_users SET "
	statement = statement .. " user_gold = " .. self.gold  .. ", "
	statement = statement .. " user_sequence = " .. self.sequence  .. " "
	statement = statement .. " WHERE user_id = " .. 1
	-- print ( query )
	q = sql:exe( statement )
end
